<template>
  <div>
    <div v-if="!isLoading">
      <IssueTable v-bind:issues="this.issues"
                  v-bind:version="this.version" />
    </div>
    <Spin class="spinner"
          size="large"
          fix
          v-if="isLoading"></Spin>
  </div>
</template>

<script>
import axios from "axios"
const IssueTable = () =>
  import(/* webpackChunkName: "issuetable" */ "@/components/IssueTable")

export default {
  name: "Version",
  data: () => ({
    isLoading: true,
    key: null,
    version: null,
    issues: []
  }),
  methods: {
    updateParams() {
      this.key = this.$route.params.key
      this.version = this.$route.params.version
    },
    async getIssues() {
      try {
        this.scrollToTop()
        this.isLoading = true
        let result = await axios.post(
          this.$baseApiUrl + "/releasenotes/" + this.key + "/issues",
          {
            name: this.version
          }
        )
        this.issues = result.data
        this.isLoading = false
      } catch (error) {
        this.isLoading = false
        console.error(error)
      }
    },
    scrollToTop() {
      window.scrollTo(0, 0)
    }
  },
  async mounted() {
    this.updateParams()
    await this.getIssues()
  },
  watch: {
    async $route() {
      this.updateParams()
      await this.getIssues()
    }
  },
  components: {
    IssueTable
  }
}
</script>

<style lang="scss" scoped>
.spinner {
  z-index: 1001;
}
</style>

